
withobject "CorelDraw.Automation.9" 

global x_led&, y_led&, corner&, r&
global offx&,offy&
global col%, led_square%
global mm&, cm&, Zoll&

rem global posx&, posy& 

global posx& (0 to 8) 
global posy& (0 to 3) 
global tastx&  
global num_taster%

sub jHole (x&, y&, n$)
	obj$="H$"+n$
	PRINT #1, "SHOW "+obj$+";"
	PRINT #1, "MOVE "+obj$+" ("+STR$((x-offx)/mm)+" "+str$((y-offy)/mm)+");"
end sub

sub jRestrict (x&, y&, c%)
	obj$ = "V$"+chr$(c+64)+LTRIM$(STR$(col))
	PRINT #1, "SHOW "+obj$+";"
	PRINT #1, "MOVE "+obj$+" ("+STR$((x-offx)/mm)+" "+str$((y-offy)/mm)+");"
end sub

sub jLED (x&, y&, c%)
rem 	et& = MESSAGEBOX ("sub", "sub", 1)
	if led_square = 2 then
		posx&(col) = x
		posy&(c-1) = y
		.CreateEllipse x+x_led/2, y-x_led/2, x-x_led/2, y+x_led/2, 0, 0, 0 
	else	
		.CreateRectangle x+x_led/2, y-y_led/2, x-x_led/2, y+y_led/2, corner, corner, corner, corner
	endif
	.StoreColor 5, 255, 255, 255, 0, 0
	.ApplyUniformFillColor
	
	rem jRestrict x, y, c
	
	obj$ = "D."+chr$(c+64)+LTRIM$(STR$(col))
	PRINT #1, "SHOW "+obj$+";"
	PRINT #1, "MOVE "+obj$+" ("+STR$((x-offx)/mm)+" "+str$((y-offy)/mm)+");"
	col% = col-1
end sub

sub jTaster (x&, y&, c%)
	.CreateEllipse x+r, y-r, x-r, y+r, 0, 0, 0 
	.StoreColor 5, 255, 255, 255, 0, 0
	.ApplyUniformFillColor
	
	obj$ = "S"+chr$(c+64)
	PRINT #1, "SHOW "+obj$+";"
	PRINT #1, "MOVE "+obj$+" ("+STR$((x-offx)/mm)+" "+str$((y-offy)/mm)+");"
end sub


.FileNew

OPEN "d:\eagle\scr\place-galois.scr" for output as 1

PRINT #1, "GRID MM FINEST;"

rem =0 : LEDs rechteckig
rem =1 : LEDs quadratisch
rem =2 : LEDs rund
led_square = 2

rem = 0: Kein Taster
rem = 1: Taster in der Mitte
taster_mitte = 1


REM 1 mm
mm& = 10000.0
cm& = 10.0*mm

taster_diam& = CLNG(4*mm)
r& = CLNG(taster_diam/2)

rem 1 Zoll = 25.4mm
Zoll& = 25.4*unit

rem Breite/Durchmesser LED
x_led& = CLNG(3.25*mm)

rem Hhe LED
if led_square = 0 then
	y_led& = CLNG(5.08*mm)
else	
	y_led& = x_led
endif

rem Abstand LED-Mitten Schalter
dx_taster& = CLNG(2.54*cm)
dx_taster& = CLNG(2.25*cm)

rem Abstand x-Richtung LED-Mitten (klein)
dx_klein& = CLNG(1.5*cm)
rem dx_klein& = CLNG(1.27*cm)

rem Abstand x-Richtung LED-Mitten (gro)
dx_gross& = CLNG(1.5*cm)
rem dx_gross& = CLNG(1.27*cm)

rem Abstand y-Richtung LED-Mitten
if led_square <> 0 then
	dy& = dx_klein
else	
	dy&       = CLNG(0.45*Zoll)
endif	

rem Abstand Rand <-> LED-Rand
d_rand&  = CLNG(10*mm)

rem Eckradius der Rechtecke
corner& = CLNG (0.5*mm)

rem Untere linke Ecke der unteren linken LED
offx& = -9*cm
offy& = -5*cm

py& = offy

for c% = 1 to 3
	col% = 8
	px& = offx
	jLED px, py, c : px& = px + dx_gross
	
	jLED px, py, c : px& = px + dx_klein
	jLED px, py, c : px& = px + dx_klein
	
	if taster_mitte = 0 then
		jLED px, py, c : px& = px + dx_gross
	endif

	if taster_mitte = 1 then
		jLED px, py, c : px& = px + dx_taster
rem		jTaster px, py, c :
		tastx& = px
		px& = px + dx_taster
	endif
	
	jLED px, py, c : px& = px + dx_klein
	jLED px, py, c : px& = px + dx_gross
	
	jLED px, py, c : px& = px + dx_klein
	jLED px, py, c : px& = px + dx_klein
	jLED px, py, c 
	py& = py + dy
	
next c	

h_ya = 0*mm
h_yb = 25*mm

num_taster%= 3

if taster_mitte = 1 then
	if num_taster = 4 then
		jTaster tastx&, posy&(0), 1
		jTaster tastx&, CLNG((2*posy&(0)+posy&(2))/3), 2
		jTaster tastx&, CLNG((posy&(0)+2*posy&(2))/3), 3
		jTaster tastx&, posy&(2), 4
	else
		jTaster tastx&, posy&(0), 1
		jTaster tastx&, posy&(1), 2
		jTaster tastx&, posy&(2), 3
	endif
endif


jHole CLNG((posx&(0)+posx&(1))/2),  CLNG(posy&(0)), "A1"
jHole CLNG((posx&(0)+posx&(1))/2),  CLNG(posy&(2)), "B1"

jHole CLNG(posx&(0)),  CLNG((posy&(0)+posy&(1))/2), "A5"
jHole CLNG(posx&(0)),  CLNG((posy&(1)+posy&(2))/2), "B5"

jHole CLNG((posx&(8)+posx&(7))/2),  CLNG(posy&(0)), "A2"
jHole CLNG((posx&(8)+posx&(7))/2),  CLNG(posy&(2)), "B2"

rem jHole CLNG(posx&(8)),  CLNG((posy&(0)+posy&(1))/2), "A6"
rem jHole CLNG(posx&(8)),  CLNG((posy&(1)+posy&(2))/2), "B6"

jHole CLNG((posx&(1)+posx&(2))/2),  CLNG((posy&(0)+posy&(1))/2), "A7"
jHole CLNG((posx&(1)+posx&(2))/2),  CLNG((posy&(1)+posy&(2))/2), "B7"

jHole CLNG((posx&(6)+posx&(7))/2),  CLNG((posy&(0)+posy&(1))/2), "A3"
jHole CLNG((posx&(5)+posx&(6))/2),  CLNG(posy&(1)), "B3"

jHole CLNG((posx&(3)+posx&(4))/2),  CLNG((posy&(0)+posy&(1))/2), "A4"
jHole CLNG((posx&(3)+posx&(4))/2),  CLNG((posy&(1)+posy&(2))/2), "B4"

rem jHole CLNG((posx&(4)+tastx&)/2),  CLNG(posy&(2)), "B3"

rem jHole CLNG(offx +  7.5*mm),  CLNG (offy + 24*mm), "B1"

rem jHole CLNG(offx + 43.5*mm),  CLNG (offy +  0*mm), "A2"
rem jHole CLNG(offx + 43.5*mm),  CLNG (offy + 24*mm), "B2"

rem jHole CLNG(offx +106.5*mm),  CLNG (offy +  0*mm), "A3"

rem jHole CLNG(offx +156.5*mm),  CLNG (offy +  0*mm), "A4"
rem jHole CLNG(offx +156.5*mm),  CLNG (offy + 24*mm), "B4"

d_randx& = d_rand+x_led/2
d_randy& = d_rand+y_led/2

.CreateRectangle px+d_randx, offy-d_randy, offx-d_randx, py-dy+d_randy, 0, 0, 0, 0
.StoreColor 5, 240, 240, 240, 0, 0
.ApplyUniformFillColor
.OrderToBack



PRINT #1, "GRID LAST;"
CLOSE

end withobject
