
withobject "CorelDraw.Automation.9"

global x_led&, y_led&, corner&, r&
global offx&,offy&
global col%, led_square%
global mm&, cm&, Zoll&

sub jHole (x&, y&, n$)
	obj$="H$"+n$
	PRINT #1, "SHOW "+obj$+";"
	PRINT #1, "MOVE "+obj$+" ("+STR$((x-offx)/mm)+" "+str$((y-offy)/mm)+");"
end sub

sub jRestrict (x&, y&, c%)
	obj$ = "V$"+chr$(c+64)+LTRIM$(STR$(col))
	PRINT #1, "SHOW "+obj$+";"
	PRINT #1, "MOVE "+obj$+" ("+STR$((x-offx)/mm)+" "+str$((y-offy)/mm)+");"
end sub

sub jLED (x&, y&, c%)
rem 	et& = MESSAGEBOX ("sub", "sub", 1)
	if led_square = 2 then
		.CreateEllipse x+x_led/2, y-x_led/2, x-x_led/2, y+x_led/2, 0, 0, 0 
	else	
		.CreateRectangle x+x_led/2, y-y_led/2, x-x_led/2, y+y_led/2, corner, corner, corner, corner
	endif
	.StoreColor 5, 255, 255, 255, 0, 0
	.ApplyUniformFillColor
	
	rem jRestrict x, y, c
	
	obj$ = "D."+chr$(c+64)+LTRIM$(STR$(col))
	PRINT #1, "SHOW "+obj$+";"
	PRINT #1, "MOVE "+obj$+" ("+STR$((x-offx)/mm)+" "+str$((y-offy)/mm)+");"
	col% = col-1
end sub

sub jCircle (x&, y&, c%)
	.CreateEllipse x+r, y-r, x-r, y+r, 0, 0, 0 
	.StoreColor 5, 255, 255, 255, 0, 0
	.ApplyUniformFillColor
	
	obj$ = "S"+chr$(c+64)
	PRINT #1, "SHOW "+obj$+";"
	PRINT #1, "MOVE "+obj$+" ("+STR$((x-offx)/mm)+" "+str$((y-offy)/mm)+");"
end sub


.FileNew

OPEN "d:\eagle\scr\place-galois.scr" for output as 1

PRINT #1, "GRID MM FINEST;"

rem =0 : LEDs rechteckig
rem =1 : LEDs quadratisch
rem =2 : LEDs rund
led_square = 2

rem = 0: Kein Taster
rem = 1: Taster in der Mitte
taster_mitte = 1


REM 1 mm
mm& = 10000.0
cm& = 10.0*mm

taster_diam& = CLNG(4*mm)
r& = CLNG(taster_diam/2)

rem 1 Zoll = 25.4mm
Zoll& = 25.4*unit

rem Breite/Durchmesser LED
x_led& = CLNG(3.25*mm)

rem Hhe LED
if led_square = 0 then
	y_led& = CLNG(5.08*mm)
else	
	y_led& = x_led
endif

rem Abstand LED-Mitten Schalter
dx_taster& = CLNG(2.54*cm)

rem Abstand x-Richtung LED-Mitten (klein)
dx_klein& = CLNG(1.524*cm)

rem Abstand x-Richtung LED-Mitten (gro)
dx_gross& = CLNG(2.54*cm)

rem Abstand y-Richtung LED-Mitten
if led_square <> 0 then
	dy& = dx_klein
else	
	dy&       = CLNG(0.45*Zoll)
endif	

rem Abstand Rand <-> LED-Rand
d_rand&  = CLNG(10*mm)

rem Eckradius der Rechtecke
corner& = CLNG (0.5*mm)

rem Untere linke Ecke der unteren linken LED
offx& = -9*cm
offy& = -5*cm

py& = offy

for c% = 1 to 3
	col% = 8
	px& = offx
	jLED px, py, c : px& = px + dx_gross
	
	jLED px, py, c : px& = px + dx_klein
	jLED px, py, c : px& = px + dx_klein
	
	if taster_mitte = 0 then
		jLED px, py, c : px& = px + dx_gross
	endif

	if taster_mitte = 1 then
		jLED px, py, c : px& = px + dx_taster
		jCircle px, py, c : px& = px + dx_taster
	endif
	
	jLED px, py, c : px& = px + dx_klein
	jLED px, py, c : px& = px + dx_gross
	
	jLED px, py, c : px& = px + dx_klein
	jLED px, py, c : px& = px + dx_klein
	jLED px, py, c 
	py& = py + dy
	
next c	

h_ya = 0*mm
h_yb = 25*mm

jHole CLNG(offx +  7.5*mm),  CLNG (offy +  0*mm), "A1"
jHole CLNG(offx +  7.5*mm),  CLNG (offy + 24*mm), "B1"

jHole CLNG(offx + 43.5*mm),  CLNG (offy +  0*mm), "A2"
jHole CLNG(offx + 43.5*mm),  CLNG (offy + 24*mm), "B2"

jHole CLNG(offx +106.5*mm),  CLNG (offy +  0*mm), "A3"

jHole CLNG(offx +156.5*mm),  CLNG (offy +  0*mm), "A4"
jHole CLNG(offx +156.5*mm),  CLNG (offy + 24*mm), "B4"

d_randx& = d_rand+x_led/2
d_randy& = d_rand+y_led/2

.CreateRectangle px+d_randx, offy-d_randy, offx-d_randx, py-dy+d_randy, 0, 0, 0, 0
.StoreColor 5, 240, 240, 240, 0, 0
.ApplyUniformFillColor
.OrderToBack



PRINT #1, "GRID LAST;"
CLOSE

end withobject
